{$mode objfpc}{$assertions on}{$r+}
uses
  Math, SysUtils;

type
  TVar = record
    name: String;
    level, value: Integer;
  end;
  PVar = ^TVar;

var
  stack: array [1..1000] of TVar;
  top: Integer = 0;

  function Find(const name: String): PVar;
  var
    i: Integer;
  begin
    for i := top downto 1 do
      if stack[i].name = name then begin
        Exit(@stack[i]);
      end;
    Assert(false);
  end;

  function Value(const name: String): Integer;
  begin
    Result := Find(name)^.value;
    Assert(Result >= 0, name);
  end;

var
  N, i, level: Integer;
  s: String;
begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Readln(N);
  Assert(InRange(N, 1, 1000));
  level := 1;
  for i := 1 to N do begin
    Readln(s);
    Assert(s <> '');
    case s of
    '{':
      level += 1;
    '}': begin
      while (top > 0) and (stack[top].level = level) do
        top -= 1;
      level -=1;
    end;
    'int a'..'int z': begin
      top += 1;
      stack[top].name := s[5];
      stack[top].level := level;
      stack[top].value := -1;
    end;
    'print a'..'print z':
      Writeln(Value(s[7]));
    else begin
      if s[3] in ['a'..'z'] then
        Find(s[1])^.value := Value(s[3])
      else
        Find(s[1])^.value := StrToInt(Copy(s, 3, Length(s) - 2));
    end;
    end;
  end;
  Assert(SeekEof(input));
end.
